/* 
 * Copyright (c) 2002 Michal Moskal <malekith@pld-linux.org>
 * All rights reserved. See file COPYRIGHT for details about licensing.
 *
 * $Rev: 945 $ $LastChangedDate: 2002-09-12 22:49:20 +0200 (Thu, 12 Sep 2002) $
 *
 * Iconv - charset conversions.
 */

open Iconv;

opt_struct packed_int {
    int val;
}

extern cstring gont_string_to_utf8(int, int, string, packed_int);
extern cstring gont_string_to_cstring(int, int, string, packed_int, charset);
extern charset gont_make_charset(cstring, int, int);
extern charset gont_charset_set_approx(charset, int, int);

void set_approx(charset c, approx a)
{
    switch a {
    case Choke:
	gont_charset_set_approx(c, 0, 0);
    case Quote:
	gont_charset_set_approx(c, 1, 0);
    case Convert(f):
	gont_charset_set_approx(c, 1, Hacks::ptr_of(f));
    }
}

*(cstring, int) string_to_utf8(string s)
{
    packed_int p = {val = 0};
    cstring r = gont_string_to_utf8(0, 0, s, p);
    return (r, p.val);
}

*(cstring, int) string_to_charset(string s, charset c)
{
    packed_int p = {val = 0};
    cstring r = gont_string_to_cstring(0, 0, s, p, c);
    return (r, p.val);
}

*(cstring, int) string_to_locale(string s)
    (string_to_charset(s, default_charset))

string string_of_locale_len(cstring s, int l)
{
    return string_of_charset_len(s, l, default_charset);
}

charset lookup_charset(string name)
{
    let (cname, _) = string_to_utf8(name);
    _ c = gont_make_charset(cname, 0, 0);
    if (Hacks::is_null(c))
	raise Not_found;
    return c;
}

// vim:sts=4:sw=4
